//Created by Sotiriou Christos
//(A.K.A.) Soulstorm
//users.forthnet.gr/ath/jonmecos

#ifndef ACCCLASS_H
#define ACCCLASS_H
#include "definitions.h"

using namespace std;

//**Temporary definitions
class	account;
typedef vector<account> VAccount;
VAccount bank;	//definition for the account type

//**********************************

//**This is he account to be used in each slot in the vector**
class account{
	bool open;
	 //whether the account is open
	char acc_name[30]; // the customer's name
	float moneydeposit; // the money on the bank
public:
	void set(char accname[30], float num);
	account(char txt[30]);
	
	int		compare(char *arg1);
	void	setdepos(float deposit);
	void	closeAcc();
	int retopen();
	
	account operator=(account ob);
	
	friend istream &operator>>(istream &stream, account ob);
	friend ostream &operator<<(ostream &stream, account ob);
	
};

//******Overloaded operators
ostream &operator<<(ostream &stream, account ob){
	stream << "Name:" << ob.acc_name << "\n" << "Deposit size:";
	stream << ob.moneydeposit << "\n";
	return stream;
}
//*******

#endif