//Created by Sotiriou Christos
//(A.K.A.) Soulstorm
//users.forthnet.gr/ath/jonmecos
#ifndef FUNCTIONS_H
#define FUNCTIONS_H
#include "FLoader.h"

//***********************
int		retopenpos();
void	tide_up_vector();
int		search_acc(char *arg);
void	waitForInput();
void	getval(float *a);
void	getval(int *a);
//**********************

void addAccount(){
	int		temp;
	char	on[30];
	float	kat;
	cout << "Enter a name: ";
	cin.getline(on, 30);
	
	cout << "Enter deposit size: ";
	getval(&kat);
	
	temp = retopenpos();
	if(temp < 0){
		bank.push_back(on);
		temp = search_acc(on);
	}
	bank[temp].setdepos(kat);
}

void deleteAccount(){
	char name[30];
	cout << "Enter a name to find in the bank: ";
	cin.getline(name, 30);
	int pos = search_acc(name);
	
	vector<account>::iterator alpha;
	alpha = bank.begin();
	alpha = alpha + pos;
	
	if (pos >= 0){
		bank.erase(alpha);
	}
	else
		cout << "The name you specified was not found in the bank\n";
	
}

void findAccount(char *arg){
	int i, counter = 0;
	for(i=0; i<bank.size(); i++){
		if(!bank[i].compare(arg)){
			counter++;
			cout << counter << ": " << bank[i]<< "\n";
		}
	}
	cout << counter << "total occurences\n";
	waitForInput();
}

void printToFile(char filename []){
	int i;
	ofstream myfile(filename);
	for(i=0; i<bank.size(); i++){
		myfile << bank[i];
	}
	myfile << "end of file***";
	myfile.close();	
}


void show_all(){
	int i;
	for(i=0; i<bank.size(); i++){
		cout << "Slot: " << i << "\n";
		cout << bank[i] << "\n";
	}
	waitForInput();
}
//*************************************************************************
//HELPFUL ROUTINES
int retopenpos(){
	int i;
	if(bank.size()==0)
		return -1;
	for(i=0; i<bank.size(); i++)
		if(!bank[i].retopen())
			return i;
	return -1;
}

//**The getval routines are overloaded to be used for both
//**Ints and floats. The call is made by reference
void getval(int *a){
	while (!(cin >> *a))
	{
		cin.clear();
		cin.ignore(numeric_limits<int>::max(), '\n');
		cout << "Wrong type of input. Give the input again: "; 
	}
}

void getval(float *a){
	while (!(cin >> *a))
	{
		cin.clear();
		cin.ignore(numeric_limits<int>::max(), '\n');
		cout << "Wrong type of input. Give the input again: "; 
	}	
}

//**The getval functions will store the number into the variable already
//**given at the call

//**Wait for keyboard input
void waitForInput(){
	char a;
	cout << "Give any character to proceed: ";
	cin >> a;
	cin.get();
}

//WARNING: THIS ROUTINE IS CURRENTLY DEPRECATED!!!!
//**This will check the vector for open unused slots. If any, each slot
//**will be filled with the last vector object. Then the last vector
//**Object will be deleted.
//**
void tide_up_vector(){
	int openpos = retopenpos();
	int replacement_obj = bank.size() - 1;
	
	if(openpos >= 0){
		bank[openpos] = bank[replacement_obj];
		bank.pop_back();
	}
	else{
		cout << "nothing to do!\n";
		waitForInput();
	}
}
//**(End of deprecated function)...

//**Searches the account for a string given at the argument
int search_acc(char *arg){
	int i;
	for(i=0; i<bank.size(); i++){
		if (!bank[i].compare(arg))
			return i;
	}
	return -1;
}

void newLoadFromFile(char filename[]){
	cin.get(); //clear the input from the remaining character
	bank.clear();
	FLoader loaderVector;
	
	bool val = loaderVector.loadFromFile(filename);
	if(!val){
		cout << "Process could not be completed\n";
		return;
	}
	loaderVector.cleanupVector();
	loaderVector.extractInfo();
	cout << "process has completed successfully\n";
}

#endif